## org.apache.commons.math.ode
Class AbstractIntegrator

    java.lang.Object
      org.apache.commons.math.ode.AbstractIntegrator

All Implemented Interfaces:
  FirstOrderIntegrator, ODEIntegrator

Direct Known Subclasses:
  AdaptiveStepsizeIntegrator, RungeKuttaIntegrator

    public abstract class AbstractIntegrator

extends java.lang.Object
implements FirstOrderIntegrator

Base class managing common boilerplate for all integrators.

Since:
  2.0
Version:
  $Revision: 811827 $ $Date: 2009-09-06 11:32:50 -0400 (Sun, 06 Sep 2009) $

Nested Class Summary
`private static class` `AbstractIntegrator.EndTimeChecker` Specialized event handler to stop integration.

Field Summary
`private FirstOrderDifferentialEquations` `equations` Differential equations to integrate.
`private int` `evaluations` Number of evaluations already performed.
`protected CombinedEventsManager` `eventsHandlersManager` Events handlers manager.
`private int` `maxEvaluations` Maximal number of evaluations allowed.
`private java.lang.String` `name` Name of the method.
`protected java.util.Collection<StepHandler>` `stepHandlers` Step handler.
`protected double` `stepSize` Current stepsize.
`protected double` `stepStart` Current step start time.

Constructor Summary
`protected` `AbstractIntegrator()` Build an instance with a null name.
`` `AbstractIntegrator(java.lang.String name)` Build an instance.

Method Summary
`protected CombinedEventsManager` `addEndTimeChecker(double startTime, double endTime, CombinedEventsManager manager)` Add an event handler for end time checking.
`void` `addEventHandler(EventHandler function, double maxCheckInterval, double convergence, int maxIterationCount)` Add an event handler to the integrator.
`void` `addStepHandler(StepHandler handler)` Add a step handler to this integrator.
`void` `clearEventHandlers()` Remove all the event handlers that have been added to the integrator.
`void` `clearStepHandlers()` Remove all the step handlers that have been added to the integrator.
`void` `computeDerivatives(double t, double[] y, double[] yDot)` Compute the derivatives and check the number of evaluations.
`double` `getCurrentSignedStepsize()` Get the current signed value of the integration stepsize.
`double` `getCurrentStepStart()` Get the current value of the step start time ti.
`int` `getEvaluations()` Get the number of evaluations of the differential equations function.
`java.util.Collection<EventHandler>` `getEventHandlers()` Get all the event handlers that have been added to the integrator.
`int` `getMaxEvaluations()` Get the maximal number of functions evaluations.
`java.lang.String` `getName()` Get the name of the method.
`java.util.Collection<StepHandler>` `getStepHandlers()` Get all the step handlers that have been added to the integrator.
`protected boolean` `requiresDenseOutput()` Check if one of the step handlers requires dense output.
`protected void` `resetEvaluations()` Reset the number of evaluations to zero.
`protected void` `sanityChecks(FirstOrderDifferentialEquations ode, double t0, double[] y0, double t, double[] y)` Perform some sanity checks on the integration parameters.
`protected void` `setEquations(FirstOrderDifferentialEquations equations)` Set the differential equations.
`void` `setMaxEvaluations(int maxEvaluations)` Set the maximal number of differential equations function evaluations.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.ode.FirstOrderIntegrator
`integrate`

Field Detail

### stepHandlers

    protected java.util.Collection<StepHandler> stepHandlers

  Step handler.

### stepStart

    protected double stepStart

  Current step start time.

### stepSize

    protected double stepSize

  Current stepsize.

### eventsHandlersManager

    protected CombinedEventsManager eventsHandlersManager

  Events handlers manager.

### name

    private final java.lang.String name

  Name of the method.

### maxEvaluations

    private int maxEvaluations

  Maximal number of evaluations allowed.

### evaluations

    private int evaluations

  Number of evaluations already performed.

### equations

    private transient FirstOrderDifferentialEquations equations

  Differential equations to integrate.

Constructor Detail

### AbstractIntegrator

    public AbstractIntegrator(java.lang.String name)

  Build an instance.

  Parameters:
    `name` - name of the method

### AbstractIntegrator

    protected AbstractIntegrator()

  Build an instance with a null name.

Method Detail

### getName

    public java.lang.String getName()

  Get the name of the method.

  Specified by:
    `getName` in interface `ODEIntegrator`
  Returns:
    name of the method

### addStepHandler

    public void addStepHandler(StepHandler handler)

  Add a step handler to this integrator.

  The handler will be called by the integrator for each accepted step.

  Specified by:
    `addStepHandler` in interface `ODEIntegrator`
  Parameters:
    `handler` - handler for the accepted steps
  See Also:
    `ODEIntegrator.getStepHandlers()`, `ODEIntegrator.clearStepHandlers()`

### getStepHandlers

    public java.util.Collection<StepHandler> getStepHandlers()

  Get all the step handlers that have been added to the integrator.

  Specified by:
    `getStepHandlers` in interface `ODEIntegrator`
  Returns:
    an unmodifiable collection of the added events handlers
  See Also:
    `ODEIntegrator.addStepHandler(StepHandler)`, `ODEIntegrator.clearStepHandlers()`

### clearStepHandlers

    public void clearStepHandlers()

  Remove all the step handlers that have been added to the integrator.

  Specified by:
    `clearStepHandlers` in interface `ODEIntegrator`
  See Also:
    `ODEIntegrator.addStepHandler(StepHandler)`, `ODEIntegrator.getStepHandlers()`

### addEventHandler

    public void addEventHandler(EventHandler function,
                                double maxCheckInterval,
                                double convergence,
                                int maxIterationCount)

  Add an event handler to the integrator.

  Specified by:
    `addEventHandler` in interface `ODEIntegrator`
  Parameters:
    `function` - event handler
    `maxCheckInterval` - maximal time interval between switching function checks (this interval prevents missing sign changes in case the integration steps becomes very large)
    `convergence` - convergence threshold in the event time search
    `maxIterationCount` - upper limit of the iteration count in the event time search
  See Also:
    `ODEIntegrator.getEventHandlers()`, `ODEIntegrator.clearEventHandlers()`

### getEventHandlers

    public java.util.Collection<EventHandler> getEventHandlers()

  Get all the event handlers that have been added to the integrator.

  Specified by:
    `getEventHandlers` in interface `ODEIntegrator`
  Returns:
    an unmodifiable collection of the added events handlers
  See Also:
    `ODEIntegrator.addEventHandler(EventHandler, double, double, int)`, `ODEIntegrator.clearEventHandlers()`

### clearEventHandlers

    public void clearEventHandlers()

  Remove all the event handlers that have been added to the integrator.

  Specified by:
    `clearEventHandlers` in interface `ODEIntegrator`
  See Also:
    `ODEIntegrator.addEventHandler(EventHandler, double, double, int)`, `ODEIntegrator.getEventHandlers()`

### requiresDenseOutput

    protected boolean requiresDenseOutput()

  Check if one of the step handlers requires dense output.

  Returns:
    true if one of the step handlers requires dense output

### getCurrentStepStart

    public double getCurrentStepStart()

  Get the current value of the step start time ti.

  This method can be called during integration (typically by the object implementing the `differential equations` problem) if the value of the current step that is attempted is needed.

  The result is undefined if the method is called outside of calls to `integrate`.

  Specified by:
    `getCurrentStepStart` in interface `ODEIntegrator`
  Returns:
    current value of the step start time ti

### getCurrentSignedStepsize

    public double getCurrentSignedStepsize()

  Get the current signed value of the integration stepsize.

  This method can be called during integration (typically by the object implementing the `differential equations` problem) if the signed value of the current stepsize that is tried is needed.

  The result is undefined if the method is called outside of calls to `integrate`.

  Specified by:
    `getCurrentSignedStepsize` in interface `ODEIntegrator`
  Returns:
    current signed value of the stepsize

### setMaxEvaluations

    public void setMaxEvaluations(int maxEvaluations)

  Set the maximal number of differential equations function evaluations.

  The purpose of this method is to avoid infinite loops which can occur for example when stringent error constraints are set or when lots of discrete events are triggered, thus leading to many rejected steps.

  Specified by:
    `setMaxEvaluations` in interface `ODEIntegrator`
  Parameters:
    `maxEvaluations` - maximal number of function evaluations (negative values are silently converted to maximal integer value, thus representing almost unlimited evaluations)

### getMaxEvaluations

    public int getMaxEvaluations()

  Get the maximal number of functions evaluations.

  Specified by:
    `getMaxEvaluations` in interface `ODEIntegrator`
  Returns:
    maximal number of functions evaluations

### getEvaluations

    public int getEvaluations()

  Get the number of evaluations of the differential equations function.

  The number of evaluations corresponds to the last call to the `integrate` method. It is 0 if the method has not been called yet.

  Specified by:
    `getEvaluations` in interface `ODEIntegrator`
  Returns:
    number of evaluations of the differential equations function

### resetEvaluations

    protected void resetEvaluations()

  Reset the number of evaluations to zero.

### setEquations

    protected void setEquations(FirstOrderDifferentialEquations equations)

  Set the differential equations.

  Parameters:
    `equations` - differential equations to integrate
  See Also:
    `computeDerivatives(double, double[], double[])`

### computeDerivatives

    public void computeDerivatives(double t,
                                   double[] y,
                                   double[] yDot)
                            throws DerivativeException

  Compute the derivatives and check the number of evaluations.

  Parameters:
    `t` - current value of the independent time variable
    `y` - array containing the current value of the state vector
    `yDot` - placeholder array where to put the time derivative of the state vector
  Throws:
    `DerivativeException` - this exception is propagated to the caller if the underlying user function triggers one

### sanityChecks

    protected void sanityChecks(FirstOrderDifferentialEquations ode,
                                double t0,
                                double[] y0,
                                double t,
                                double[] y)
                         throws IntegratorException

  Perform some sanity checks on the integration parameters.

  Parameters:
    `ode` - differential equations set
    `t0` - start time
    `y0` - state vector at t0
    `t` - target time for the integration
    `y` - placeholder where to put the state vector
  Throws:
    `IntegratorException` - if some inconsistency is detected

### addEndTimeChecker

    protected CombinedEventsManager addEndTimeChecker(double startTime,
                                                      double endTime,
                                                      CombinedEventsManager manager)

  Add an event handler for end time checking.

  This method can be used to simplify handling of integration end time. It leverages the nominal stop condition with the exceptional stop conditions.

  Parameters:
    `startTime` - integration start time
    `endTime` - desired end time
    `manager` - manager containing the user-defined handlers
  Returns:
    a new manager containing all the user-defined handlers plus a dedicated manager triggering a stop event at entTime

Copyright (c) 2003-2011 Apache Software Foundation